const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of administrationRoutes by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} administrationRoutes - The array of administrationRoutes to format.
 * @returns {Promise<Object[]>} - The formatted array of administrationRoutes.
 */
const formatWithModifier = async (administrationRoutes) => {
    return Promise.all(
        administrationRoutes.map(async (administrationRoute) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: administrationRoute.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...administrationRoute,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all administrationRoutes with their parent administrationRoute title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.administrationRoutesId - The ids of the administrationRoutes to retrieve.
 * @returns {Promise<Object>} - The response object with the administrationRoutes and success status.
 */
async function getAll(params) {
    try {
        // filters
        const filterConditions = {};

        let administrationRoutes = []
        administrationRoutes = await dbSAPPS.AdministrationRoute.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        administrationRoutes = administrationRoutes.map(administrationRoute => {
            return {
                ...administrationRoute.dataValues
            }
        });

        administrationRoutes = await formatWithModifier(administrationRoutes);

        return {
            administrationRoutes,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get administrationRoute items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the administrationRoute items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the administrationRoute items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the administrationRoute items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.AdministrationRoute.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active administrationRoute items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.AdministrationRoute.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new administrationRoute item.
 * 
 * @param {Object} params - The new administrationRoute item data.
 * @param {string} params.name - The name of the administrationRoute item.
 * @param {string} params.title - The title of the administrationRoute item.
 * @param {number} [params.parent_id] - The ID of the parent administrationRoute item.
 * @param {string} [params.url] - The URL of the administrationRoute item.
 * @param {string} [params.icon] - The icon of the administrationRoute item.
 * @param {string} [params.type=link] - The type of the administrationRoute item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the administrationRoute item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the administrationRoute item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the administrationRoute item.
 * @param {number} [params.owner=1] - The ID of the user who created the administrationRoute item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the administrationRoute item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the administrationRoute item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.AdministrationRoute.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.AdministrationRoute.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing administrationRoute item.
 * 
 * @param {number} id - The ID of the administrationRoute item to update.
 * @param {Object} params - The updated administrationRoute item data.
 * @param {string} [params.name] - The new name of the administrationRoute item.
 * @param {string} [params.title] - The new title of the administrationRoute item.
 * @param {number} [params.parent_id] - The new parent ID of the administrationRoute item.
 * @param {string} [params.url] - The new URL of the administrationRoute item.
 * @param {string} [params.icon] - The new icon of the administrationRoute item.
 * @param {string} [params.type] - The new type of the administrationRoute item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the administrationRoute item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the administrationRoute item.
 * @param {number} [params.modified] - The new last modification timestamp of the administrationRoute item.
 * @param {number} [params.owner] - The new ID of the user who created the administrationRoute item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the administrationRoute item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the administrationRoute item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const administrationRoute = await dbSAPPS.AdministrationRoute.findByPk(id);
        if (!administrationRoute) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.AdministrationRoute.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await administrationRoute.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a administrationRoute
 * @param {number} id - the id of the administrationRoute
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const administrationRoute = await dbSAPPS.AdministrationRoute.findByPk(id);
        if (!administrationRoute) return { success: false, message: 'ID not found!' };

        // delete
        await administrationRoute.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
